<script src="./Attribute.js"></script>

<template>
  <div v-if="attributes && attributes.length > 0">
    <div
      class="form-group m-form__group"
      v-for="(attribute, index) in attributes"
      :key="index"
      :class="{ 'has-danger': errors.has(scope + '.' + attribute.attribute_code) || server_errors[attribute.attribute_code] }"
    >
      <label :for="attribute.attribute_code" class="form-control-label nt-label">
        {{ attribute.attribute_name }}
        <span class="m--font-danger" v-if="attribute.is_required">*</span>
      </label>

      <template v-if="attribute.data_type_id">
        <template v-if="attribute.data_type_id == isText">
          <s-input-text
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false, max: 250 }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            @keyup="changeDataInputType(attribute.attribute_code)"
          ></s-input-text>
        </template>

        <template v-if="attribute.data_type_id == isDate">
          <s-input-date
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            @change="changeDataInputType(attribute.attribute_code)"
          ></s-input-date>
        </template>

        <template v-if="attribute.data_type_id == isDateTime">
          <s-input-date-time
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            @change="changeDataInputType(attribute.attribute_code)"
          ></s-input-date-time>
        </template>

        <template v-if="attribute.data_type_id == isPhone">
          <s-input-phone
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false, regex: helpers.regexPhone() }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            @keyup="changeDataInputType(attribute.attribute_code)"
          ></s-input-phone>
        </template>

        <template v-if="attribute.data_type_id == isEmail">
          <s-input-email
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false, regex: helpers.regexEmail(), max: 250 }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            @keyup="changeDataInputType(attribute.attribute_code)"
          ></s-input-email>
        </template>

        <template v-if="attribute.data_type_id == isNumber">
          <!--<vue-numeric class="form-control" v-bind:max="99999999999999999999" v-bind:precision="2" separator="." :data-vv-scope="scope" v-model="attribute.attribute_value" v-validate="{ required: attribute.is_required ? true : false }" :id="attribute.attribute_code" :name="attribute.attribute_code" @keyup.native="changeDataInputType(attribute.attribute_code)"></vue-numeric>-->
          <s-input-number-custom
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            @keyup="changeDataInputType(attribute.attribute_code)"
          ></s-input-number-custom>
          <!--   <s-input-number :data-vv-scope="scope" v-model="attribute.attribute_value" v-validate="{ required: attribute.is_required ? true : false }" :id="attribute.attribute_code" :name="attribute.attribute_code"></s-input-number> -->
        </template>

        <template v-if="attribute.data_type_id == isPrice">
          <!--@Todo Sau này làm component input price theo vnđ-->
          <!--   <s-input-number :data-vv-scope="scope" v-model="attribute.attribute_value" v-validate="{ required: attribute.is_required ? true : false }" :id="attribute.attribute_code" :name="attribute.attribute_code" @keyup="changeDataInputType(attribute.attribute_code)"></s-input-number> -->
          <s-input-number-custom
            :is_decimal="false"
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            @keyup="changeDataInputType(attribute.attribute_code)"
          ></s-input-number-custom>

          <!--<s-input-price :data-vv-scope="scope" v-model="attribute.attribute_value" v-validate="{ required: attribute.is_required ? true : false, numeric: true, max: 20 }" :check_number="true" :id="attribute.attribute_code" :name="attribute.attribute_code" @keyup="changeDataInputType(attribute.attribute_code)"></s-input-price>-->
        </template>

        <template v-if="attribute.data_type_id == isSelect">
          <s-select
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            :data="attribute.attribute_options"
            :label="'option_value'"
            @change="changeDataInputType(attribute.attribute_code)"
          ></s-select>
        </template>

        <template v-if="attribute.data_type_id == isSelectFind">
          <s-select-search
            :data-vv-scope="scope"
            v-model.number="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            :data="attribute.attribute_options"
            :label="'option_value'"
            @change="changeDataInputType(attribute.attribute_code)"
          ></s-select-search>
        </template>

        <template v-if="attribute.data_type_id == isMultipleSelect">
          <s-select-multiple
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            :data="attribute.attribute_options"
            :label="'option_value'"
            @change="changeDataInputType(attribute.attribute_code)"
          ></s-select-multiple>
        </template>

        <template v-if="attribute.data_type_id == isTag">
          <!--@Todo Sau này làm component tags-->
          <s-tags
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            :data="attribute.attribute_options"
            :label="'option_value'"
            @change="changeDataInputType(attribute.attribute_code)"
          ></s-tags>
        </template>

        <template v-if="attribute.data_type_id == isTextArea">
          <s-textarea
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false, max: 1025 }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            @keyup="changeDataInputType(attribute.attribute_code)"
          ></s-textarea>
        </template>

        <template v-if="attribute.data_type_id == isCheckboxMultiple">
          <s-checkbox-multiple
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            :data="attribute.attribute_options"
            :label="'option_value'"
            @keyup="changeDataInputType(attribute.attribute_code)"
          ></s-checkbox-multiple>
        </template>

        <template v-if="attribute.data_type_id == isRadio">
          <s-radio-multiple
            :data-vv-scope="scope"
            :col="'col-md-6'"
            v-model="attribute.attribute_value"
            :label="'option_value'"
            v-validate="{ required: attribute.is_required ? true : false }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            :data="attribute.attribute_options"
            @keyup="changeDataInputType(attribute.attribute_code)"
          ></s-radio-multiple>
        </template>

        <template v-if="attribute.data_type_id == isUser">
          <v-select
            v-model="attribute.attribute_value"
            label="full_name"
            :options="listUsers"
            index="id"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            :data-vv-scope="scope"
            v-validate="{ required: attribute.is_required ? true : false }"
            @change="changeDataInputType(attribute.attribute_code)"
          >
            <template slot="option" slot-scope="option">
              <b>{{ option.full_name | truncateWords }}</b>
              <br />
              {{ option.email | truncateWords }}
            </template>
          </v-select>
        </template>

        <template v-if="attribute.data_type_id == isUserMultiple">
          <v-select
            v-model="attribute.attribute_value"
            label="full_name"
            :options="listUsers"
            index="id"
            multiple
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            :data-vv-scope="scope"
            v-validate="{ required: attribute.is_required ? true : false }"
            @change="changeDataInputType(attribute.attribute_code)"
          >
            <template slot="option" slot-scope="option">
              <b>{{ option.full_name | truncateWords }}</b>
              <br />
              {{ option.email | truncateWords }}
            </template>
          </v-select>
        </template>
      </template>

      <div
        class="form-control-feedback m--font-danger"
        v-if="server_errors != '' && server_errors[attribute.attribute_code]"
      >
        <template
          v-if="server_errors[attribute.attribute_code][0].is_unique"
        >{{ attribute.attribute_name }} bị trùng.</template>
        <template
          v-else-if="server_errors[attribute.attribute_code][0].is_required"
        >Không được để trống trường này.</template>
        <template
          v-else-if="server_errors[attribute.attribute_code].not_exist"
        >{{ attribute.attribute_name }} đã bị xóa, vui lòng tải lại trang.</template>
        <template v-else>{{ server_errors[attribute.attribute_code][0] }}</template>
      </div>

      <div
        class="form-control-feedback m--font-danger"
        v-else-if="errors.has(scope + '.' + attribute.attribute_code)"
      >
        <div v-for="(error, indexA) in errors.items" :key="indexA">
          <template v-if="errors.items.length > 0">
            <template
              v-if="attribute.attribute_code == error.field && error.rule == 'required'"
            >Không được để trống trường này.</template>
            <template v-if="attribute.attribute_code == error.field && error.rule == 'max'">
              <template v-if=" attribute.data_type_id == isPrice">Giới hạn 20 ký tự.</template>
              <template v-else-if=" attribute.data_type_id == isTextArea">Giới hạn 1025 ký tự.</template>
              <template v-else>Giới hạn 250 ký tự.</template>
            </template>

            <template v-if="attribute.attribute_code == error.field && error.rule == 'regex'">
              Định dạng
              <span class="text-lowercase">{{ attribute.attribute_name }}</span> không đúng.
            </template>

            <template
              v-if="attribute.attribute_code == error.field && error.rule == 'numeric'"
            >Giá chỉ được điền số >= 0.</template>
          </template>
        </div>
      </div>

      <div class="form-control-feedback m--font-danger" v-else>&nbsp;</div>
    </div>
  </div>
</template>
